def text
pipeline {

    agent { label 'dockerVM' }

    stages {
        stage('Build') {
            steps{
                sh "chmod 777 -R gradlew"
                sh "./gradlew clean"
                
                script{
                    text = readFile './src/main/resources/application.properties'
                    text = text.replaceAll('database.url=jdbc:mysql://localhost:3306/social_network_database', 'database.url=jdbc:mysql://172.20.0.100:3306/social_network_database')
                    text = text.replaceAll('database.username=admin', 'database.username=cs_user')
                    text = text.replaceAll("database.password=admin", "database.password=Password1234")
                }
                
                sh "rm ./src/main/resources/application.properties"
                writeFile file: './src/main/resources/application.properties', text: "${text}"
                sh "./gradlew build"
            }
        }
    
        stage('Docker'){
            steps{
                writeFile file: 'Dockerfile', text: 
                '''
                    FROM openjdk:8
                    COPY ./build/libs/*.jar .
                    EXPOSE 8080
                    ENTRYPOINT ["java", "-jar", "project-0.0.1-SNAPSHOT.jar"] 
                '''
                script{
                    docker.build("cs_stage_container")    
                }
                
            }
        }
        
        stage("Start container"){
            steps{
                sh "docker stop cs_stage_cont"
                sh "docker container prune -f"
                sh "docker run -d --name cs_stage_cont -p 8081:8080 cs_stage_container"
                sh "docker network connect --ip 172.20.0.111 my-network2 cs_stage_cont"
                sh "docker image prune -af"
            }
        }
    }
}